# react-amap Contributing Guide

Hi! Thank you for choosing react-amap.

React-amap is a Map Components Based On React and AMap(amap.com)

We are excited that you are interested in contributing to react-amap. Before submitting your contribution though, please make sure to take a moment and read through the following guidelines.

## Issue Guidelines
- Issues are exclusively for bug reports and feature requests. Other questions may be closed directly.

- Before submitting an issue, please check if similar problems have already been issued.

- Please specify which version of react-amap you are using, and provide OS and browser information. [JSFiddle](https://jsfiddle.net/) is recommended to build a live demo so that your issue can be reproduced clearly.

## Pull Request Guidelines
- Fork this repository to your own account. Do not create branches here.

- **DO NOT** include files inside `lib` directory.

- Rebase before creating a PR to keep commit history clear.

- If you are fixing a bug, please include detailed description of the bug in the PR.

- Merging a PR takes two maintainers: one approves the changes after reviewing, and then the other reviews and merges.

## Code Style
Just comply with the [ESLint](https://github.com/ElemeFE/eslint-config-elemefe) configuration of [ElemeFE](https://github.com/elemefe).
